<!doctype html>
<html lang="es_ES" xmlns:th="http://www.thymeleaf.org">
<head>
    <!-- Required meta tags -->
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet"
          integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">

    <!-- Estilos personalizados -->
    <link href="css/custom.css" type="text/css" rel="stylesheet">

    <title th:text="${titulo}"></title>
</head>
<body>
<div th:include="_navbar :: navBar"></div>
<div class="container">
    <h1 class="text-secondary mb-3" th:text="${titulo}"></h1>
    <form th:action="@{/nuevacat}" th:object="${cat}" method="post">
        <div class="input-group mb-3">
            <button class="btn btn-success btn-xs" type="submit" id="btnCreacat" disabled>Añadir categoría</button>
            <input type="text" th:field="*{categoria}" id="categoria" class="form-control"
                   oninput="monitorCat()" placeholder="" aria-label="Añadir categoría"
                   aria-describedby="button-addon1"/>
        </div>
    </form>
    <table class="table table-striped">
        <thead>
        <tr>
            <th>ID</th>
            <th>Categoria</th>
            <th></th>
            <th></th>
        </tr>
        </thead>
        <tbody>
        <tr th:each="categoria: ${categorias}">
            <td th:text="${categoria.idCategoria}"></td>
            <td th:text="${categoria.categoria}"></td>
            <td><a class="btn btn-danger btn-xs" th:href="@{/borrar/} + ${categoria.idCategoria}" th:text="'Eliminar'"
                   onclick="return confirm('Estás seguro que quieres eliminar?');"></a></td>
            <td>
                <!-- Pasamos al modal el objeto categoría -->
                <button class="btn btn-primary editar" type="button" data-bs-toggle="modal"
                        data-th-attr="data-bs-target='#editCatModal-' + ${categoria.idCategoria},
                        data-id=${categoria.idCategoria},
                        data-categoria=${categoria.categoria}">
                    Editar
                </button>

                <th:block th:replace="_modals :: modal(${categoria.idCategoria})">modal</th:block>

            </td>
        </tr>
        </tbody>
    </table>

</div>

<script src="https://code.jquery.com/jquery-3.6.0.min.js"
        integrity="sha256-/xUj+3OJU5yExlq6GSYGSHk7tPXikynS7ogEvDej/m4=" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.9.2/dist/umd/popper.min.js"
        integrity="sha384-IQsoLXl5PILFhosVNubq5LC7Qb9DXgDA9i+tQ8Zj3iwWAwPtgFTxbJ8NT4GN1R8p"
        crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.min.js"
        integrity="sha384-cVKIPhGWiC2Al4u+LWgxfKTRIcfu0JTxR+EQDz/bgldoEyl4H0zUF0QKbrJ0EcQF"
        crossorigin="anonymous"></script>
<script type="text/javascript">
    function monitorCat() {
        const el = document.getElementById("categoria").value.trim();
        console.log(el);
        if (!el) {
            document.getElementById("btnCreacat").setAttribute("disabled", "disabled")
        } else {
            document.getElementById("btnCreacat").removeAttribute("disabled")
        }
    }

    // Creamos la matriz con todos los botones "Editar" de la tabla de categorías
    let btns = document.querySelectorAll('.editar')

    for (let i=0; i< btns.length; i++) {
        // a cada uno le añadimos un "escuchador" del evento "click"
        btns[i].addEventListener('click', function(event) {
            var button = event.target                // Botón que abre el modal
            // Sacamos la info de los atributos data-*
            var params = {
                idCategoria : button.dataset.id,
                categoria : button.dataset.categoria
            };

            // llamamos al punto de entrada que tiene que devolver el formulario a insertar en el modal
            fetch ("/editacat", {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json;charset=utf-8'
                },
                body: JSON.stringify(params)
            })
                .then(resp => resp = resp.text())
                // insertamos el fomulario ya con la categoría a modificar
                .then(txt => $('#editCatModal-'+params.idCategoria).find('.modal-content').html(txt))
                .catch(err => {
                    console.log(err)
                })
        })
    }



</script>
</body>
</html>